using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        Label1.Text = "";
    }
    public DataTable GetData
    {
        get
        {
            if (Session["Data"] == null)
            {
                DataTable table = new DataTable();
                table.Columns.Add("ID");
                table.Columns.Add("Name");
                table.Columns.Add("IsHead", typeof(Boolean));
                for (int i = 1; i <= 10; i++)
                {
                    table.Rows.Add(i, "Name" + i.ToString(), (i == 1 ? true : false));
                }
                Session["Data"] = table;
            }
            return (DataTable)Session["Data"];
        }
    }
    protected void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = GetData;
    }
    protected void CheckBox1_CheckedChanged(object sender, EventArgs e)
    {
        Label1.Text = "Checked: " + (sender as CheckBox).Checked.ToString();
    }
    protected void RadGrid1_ItemCommand(object source, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.UpdateCommandName)
        {
            GridEditableItem editedItem = e.Item as GridEditableItem;
            DataTable table = GetData;
            //Locate the changed row in the DataSource
            DataRow[] changedRows = table.Select("ID = " +
                      editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["ID"].ToString());
            if (changedRows.Length != 1)
            {
                this.Label1.Text += "Unable to locate the Order for updating.";
                e.Canceled = true;
                return;
            }
            //Update new values
            Hashtable newValues = new Hashtable();
            e.Item.OwnerTableView.ExtractValuesFromItem(newValues, editedItem);
            changedRows[0].BeginEdit();
            try
            {
                foreach (DictionaryEntry entry in newValues)
                {
                    changedRows[0][(string)entry.Key] = entry.Value;
                }
                changedRows[0].EndEdit();
            }
            catch (Exception ex)
            {
                changedRows[0].CancelEdit();
                Label1.Text += "Unable to update Orders. Reason: " + ex.Message;
                e.Canceled = true;
            }
        }
    }
}
